function [fv,sp] = filtvert_mult(Y,X_fix,X_ms,eta,parms_n,parms_s,sig,nvars);

% FILTVERT filterverteilung
% function call
nst=size(eta,1);
p = ones(nst,1)/nst;
n = length(Y)/nvars+1;
fv = zeros(n,length(p));
fv(1,:) = p';
sp = 0;

Z=[X_fix X_ms];
if size(sig,3)==1;
    sig=sig(:,:,ones(nst,1));
end

for i = 2:n
    ext = eta'*p;
    [lh  maxl] = likeli(Y((i-2)*nvars+1:(i-1)*nvars),Z((i-2)*nvars+1:(i-1)*nvars,:),parms_n,parms_s,sig,nst);    % use likelihood function
    p = ext.*lh;
    sp = sp + log(sum(p))+ maxl;
    p = p / sum(p);
    fv(i,:) = p';
end

