states=1:nst;
%INITIALIZING parameters and matrices to save, ADJUST in particular
%starting value for state vector: lines 27-28 and/or 34-35
% and for gamma: line 43
if test==0;
    [ind_VAR_n,ind_parms_n]=findparms(ind_n,const,exo);
    [ind_VAR_s,ind_parms_s]=findparms(ind_s,const,exo);
    parms_n=zeros(length(prm_n),1); %non-switching parameters
    parms_s=zeros(size(X_ms,2),nst); %switching parameters
    parms_s([ind_parms_s(1,ind_parms_s(1,:)>0)],2)=mean(y(y(:,1)>0,ind_s(:,1)>0))';
    %the rows corresponding to the constant (in state two) are filled with the mean of the variables

    res1=y(2:end,:)-y(1:end-1,:)*inv(y(1:end-1,:)'*y(1:end-1,:))*y(1:end-1,:)'*y(2:end,:);
    sig=res1'*res1/size(y,1); %residuals' variance
    %alternative: sig=1/(nu0)*sig0;
    if sigswitch
        sig=sig(:,:,ones(1,nst));
    end

    eta=[];
    tvp=[];
    gam=zeros(gadim,1);
    if ~tvar
        e_diag=0.75;
        if nst>1;
            eta=ones(nst)*(1-e_diag)/(nst-1).*(ones(nst)-eye(nst))+eye(nst)*e_diag; %transition probabilities
            sst=[y(:,1)>mean(y(:,1))]'; %state vector
            sst=[sst(1) sst]+1;

        else eta=1;
            sst=[1 ones(1,size(y,1))];
        end
    elseif tvar
        sst=[y(:,1)>mean(y(:,1))]'; %state vector
        sst=[sst(1) sst]+1;
        Dt=sst(ones(1,nst),:)'==states(ones(length(sst),1),:);
        Dst=kron(Dt,ones(1,Zdim));
        if gz
            Zgamt=[kron(ones(1,nst),Zgam).*Dst(1:end-1,:), Dt(1:end-1,:)];
        elseif ~gz
            Zgamt=[Zgam, Dt(1:end-1,:)];
        end
        gam=cat(2,gam,[4;1; -2;2]);
        tvp= exp(Zgamt*gam - kron(log(sum(exp(Zgamt*gam),2)),ones(1,nst)));
    end

end

if test==1
    eta=[];
    parms_n=[];
    parms_s= permute([cst; reshape(ar,1,1,nst);parms],[1 3 2]) ;
    sst=IMS;
    Dt=sst(ones(1,nst),:)'==states(ones(length(sst),1),:);
    Dst=kron(Dt,ones(1,Zdim));
    Zgamt=[kron(ones(1,nst),Zgam).*Dst(1:end-1,:), Dt(1:end-1,:)];
    gam=[zeros(gadim,1) [5 5 -3 3]'];
    tvp= exp(Zgamt*gam - kron(log(sum(exp(Zgamt*gam),2)),ones(1,nst)));
    const=1;
    sst=[y(:,1)>mean(y(:,1))]'; %state vector
    sst=[sst(1) sst]+1;
end


