ind=cumsum(find(ind_s')>0);
indno=zeros(size(ind_s'));
indno(find(ind_s'))=ind;
% if id_sel
% index=idperm(it_b:end);%1:4:size(sigmc,4);
% elseif ~id_sel
%     index=it_b:size(sigmc,4)
% end

ki95=0.05;
ki90=0.10;
kil=floor(length(index)*0.05);
kiu=ceil(length(index)*0.95);

%[ctry(1:2) 'f' int2str(firms)]

if any(ind_n)
[ac, hm, sd, med, ki, ineff] = autocovneu(parmsmc_n(:,index)',1,ki95);
sparmsmc_n=sort(parmsmc_n(:,index)',1);

'non-switching parameters'
[mean(parmsmc_n(:,index),2) std(parmsmc_n(:,index),[],2) ki]
'90% int'
[ac, hm, sd, med, ki2, ineff] = autocovneu(parmsmc_n(:,index)',1,ki90);
%[mean(parmsmc_n(:,index),2) sparmsmc_n([kil kiu],:)']
[mean(parmsmc_n(:,index),2) ki2]

'P-value of 0'
sum(parmsmc_n(:,index)<=0,2)./length(index)

if size(parmsmc_n,1)>(ind_n(1)+lags)
'long-run effect of non-switching parameters'
ps=size(parmsmc_n,1)-ind_n(1)-lags;
lrfmc_n=parmsmc_n(ind_n(1)+lags+1:end,:)./ kron(ones(ps,1),(1-sum(parmsmc_n(ind_n(1)+1:ind_n(1)+lags,:),1)));
slrfmc_n=sort(lrfmc_n(:,index)',1);

[ac, hm, sd, med, ki, ineff] = autocovneu(lrfmc_n(:,index)',1,ki95);
[mean(lrfmc_n(:,index),2) std(lrfmc_n(:,index),[],2) ki]

'90% int: long-run effect of non-switching parameters'
%[mean(lrfmc_n(:,index),2) slrfmc_n([kil kiu],:)']
[ac, hm, sd, med, ki2, ineff] = autocovneu(lrfmc_n(:,index)',1,ki90);
[mean(lrfmc_n(:,index),2) ki2]

'P-value of 0, long-run effects'
sum(lrfmc_n(:,index)<=0,2)./length(index)

end

end

if any(ind_s)
[ac, hm, sd, med, ki, ineff] = autocovneu([permute(parmsmc_s(:,1,index),[3 1 2]) permute(parmsmc_s(:,2,index),[3 1 2])],1,ki95);
s1parmsmc_s=sort(permute(parmsmc_s(:,1,index),[3 1 2]),1);
s2parmsmc_s=sort(permute(parmsmc_s(:,2,index),[3 1 2]),1);

%indno=indno(1,find(indno(1,:)));
'switching paramters, first state'
%[ind(indno) squeeze(mean(parmsmc_s(indno,1,index),3)) squeeze(std(parmsmc_s(indno,1,index),[],3)) ki(indno,:)]%ki(1:size(parmsmc_s,1),:)]
[squeeze(mean(parmsmc_s(:,1,index),3)) squeeze(std(parmsmc_s(:,1,index),[],3)) ki(ind,:)]%ki(1:size(parmsmc_s,1),:)]
'90% int switching parameters, first state'
%[squeeze(mean(parmsmc_s(:,1,index),3)) s1parmsmc_s([kil kiu],:)']
[ac, hm, sd, med, ki2, ineff] = autocovneu([permute(parmsmc_s(:,1,index),[3 1 2]) permute(parmsmc_s(:,2,index),[3 1 2])],1,ki90);
[squeeze(mean(parmsmc_s(:,1,index),3)) ki2(ind,:)]

'switching parameters, second state'
%[ind(indno) squeeze(mean(parmsmc_s(indno,2,index),3)) squeeze(std(parmsmc_s(indno,2,index),[],3)) ki(size(parmsmc_s,1)+indno,:)]
[squeeze(mean(parmsmc_s(:,2,index),3)) squeeze(std(parmsmc_s(:,2,index),[],3)) ki(ind+ind(end),:)]
'90% int switching parameters, second state'
%[squeeze(mean(parmsmc_s(:,2,index),3)) s2parmsmc_s([kil kiu],:)']
[squeeze(mean(parmsmc_s(:,2,index),3)) ki2(ind+ind(end),:)]

'p-value of 0, for switching coefficients'
sum(parmsmc_s(:,:,index)<=0,3)./length(index)

ps=size(parmsmc_s,1);
% arsum=permute((1-sum(parmsmc_n(ind_n(1)+1:ind_n(1)+lags,:),1)),[1 3 2]);
% lrfmc_s=parmsmc_s./ arsum(ones(1,ps),ones(1,nst),:);
arsum=(1-sum(parmsmc_s(ind_s(1)+1:ind_s(1)+lags,:,:),1));
lrfmc_s=parmsmc_s./ arsum(ones(1,ps),:,:);
s1lrfmc_s=sort(permute(lrfmc_s(:,1,index),[3 1 2]),1);
s2lrfmc_s=sort(permute(lrfmc_s(:,2,index),[3 1 2]),1);

[ac, hm, sd, med, ki, ineff] = autocovneu([permute(lrfmc_s(:,1,index),[3 1 2]) permute(lrfmc_s(:,2,index),[3 1 2])],1,ki95);
'long-run effect of switching parameters, state 1'
[squeeze(mean(lrfmc_s(:,1,index),3)) squeeze(std(lrfmc_s(:,1,index),[],3)) ki(1:ps,:)]%ki(1:size(parmsmc_s,1),:)]

'90% int long-run effect of switching parameters, state 1'
%[squeeze(mean(lrfmc_s(:,1,index),3)) s1lrfmc_s([kil kiu],:)']
[ac, hm, sd, med, ki2, ineff] = autocovneu([permute(lrfmc_s(:,1,index),[3 1 2]) permute(lrfmc_s(:,2,index),[3 1 2])],1,ki90);
[squeeze(mean(lrfmc_s(:,1,index),3)) ki2(1:ps,:)]

'long-run effect of switching parameters, state 2'
[squeeze(mean(lrfmc_s(:,2,index),3)) squeeze(std(lrfmc_s(:,2,index),[],3)) ki(ps+1:2*ps,:)]%ki(1:size(parmsmc_s,1),:)]

'90% int long-run effect of switching parameters, state 2'
%[squeeze(mean(lrfmc_s(:,2,index),3)) s2lrfmc_s([kil kiu],:)']
[squeeze(mean(lrfmc_s(:,2,index),3)) ki2(ps+1:2*ps,:)]

'P-value of 0 for switching long-run effect'
sum(lrfmc_s(:,:,index)<=0,3)./length(index)

end

'variance, first state'
[ac, hm, sd, med, ki, ineff] = autocovneu(permute(sigmc(1,1,1,index),[4 1 2 3]),1,ki95);
%[[1:nvars]' diag(mean(sigmc(:,:,1,index),4)) diag(std(sigmc(:,:,1,index),[],4))]
[[1:nvars]' diag(mean(sigmc(:,:,1,index),4)) diag(std(sigmc(:,:,1,index),[],4)) ki]
s1sigmc=sort(sigmc(:,:,1,index),4);
'90% int variance, first state'
%[diag(mean(sigmc(:,:,1,index),4)) diag(s1sigmc(:,:,1,kil)) diag(s1sigmc(:,:,1,kiu))] 
[ac, hm, sd, med, ki2, ineff] = autocovneu(permute(sigmc(1,1,1,index),[4 1 2 3]),1,ki90);
[[1:nvars]' diag(mean(sigmc(:,:,1,index),4))  ki2]


if size(sigmc,3)>1

'variance, second state'
%[[1:nvars]' diag(mean(sigmc(:,:,2,index),4)) diag(std(sigmc(:,:,2,index),[],4))]
s2sigmc=sort(sigmc(:,:,2,index),4);
[ac, hm, sd, med, ki, ineff] = autocovneu(permute(sigmc(1,1,2,index),[4 1 2 3]),1,ki95);
[[1:nvars]' diag(mean(sigmc(:,:,2,index),4)) diag(std(sigmc(:,:,2,index),[],4)) ki]
'90% int variance, second state'
[diag(mean(sigmc(:,:,2,index),4)) diag(s2sigmc(:,:,1,kil)) diag(s2sigmc(:,:,1,kiu))] 
[ac, hm, sd, med, ki2, ineff] = autocovneu(permute(sigmc(1,1,2,index),[4 1 2 3]),1,ki90);
[[1:nvars]' diag(mean(sigmc(:,:,2,index),4))  ki2]

end



if tvar
' mean and 95% interval of transition coefficients'    
[ac, hm, sd, med, ki, ineff] = autocovneu(permute(gammc(:,2,index),[3 1 2]),1,ki95);
[hm sd ki]

'mean of transition coefficients'
mean(gammc(:,:,index),3)

'P-value of 0 for transition coefficients'
sum(gammc(:,2,index)<=0,3)./length(index)
end