function [mu,var,p]= define_normmix_kl10
% normal approximation to type 1 extreme-value distribution (minus log Exp)

% COMMENT: moments were obtained by fitting a normal mixture to log Exp
%          by minimizing the Kullback-Leibler distance
%          and are transformed to fit minus log Exp

%output: row vectors
%  mu ... means
%  var ... variances
%  p   ... weights


load -ascii approx_kl_10.asc;
p=approx_kl_10(1,:)';
mu=approx_kl_10(2,:)';
var=approx_kl_10(3,:)';
