function [fv,sp,tvpm] = filtvert_tvp(Y,X_fix,X_ms,Zgam,parms_n,parms_s,gam,sig,nvars,gz);

% FILTVERT filter distribution
% function call
if ~gz
    gam=gam([1 1:end],:);
end
nst=size(gam,2);
Zdim=size(Zgam,2);
p = ones(nst,1)/nst;
n = length(Y)/nvars+1;
fv = zeros(n,length(p));
tvpm= zeros(nst,nst,n-1);

Di= kron(ones(Zdim+1,nst),eye(nst));

fv(1,:) = p';
sp = 0;

Z=[X_fix X_ms];
if size(sig,3)==1;
    sig=sig(:,:,ones(nst,1));
end

for i = 2:n
    Zgami= kron(ones(1,nst),kron([Zgam((i-1),:) 1]',ones(nst,1)));
    gami=kron(gam.*Zgami,ones(1,nst));
    eta=reshape(sum(gami.*Di,1),nst,nst);
    eta= exp(eta-kron(ones(1,nst),log(sum(exp(eta),2))));
    tvpm(:,:,i-1)=eta;
    ext = eta'*p;
    [lh  maxl] = likeli(Y((i-2)*nvars+1:(i-1)*nvars),Z((i-2)*nvars+1:(i-1)*nvars,:),parms_n,parms_s,sig,nst);    % use likelihood function
    p = ext.*lh;
    sp = sp + log(sum(p))+ maxl;
    p = p / sum(p);
    fv(i,:) = p';
end

