function [sig,detsig,nupost,sigpost] =simsiginfo_uni(y,Zmat,par,sst,nu0,sig0,nst,sigswitch);

states=1:nst;
n=size(y,1);

S=(sst(ones(1,nst),2:end)==states(ones(1,n),:)')';
res=y-Zmat*par;
ressq=res.^2;



if sigswitch
    nupost(:,1)=nu0(ones(1,nst),:)+0.5*sum(S,1)';
    sigpost(:,1)=sig0(ones(1,nst),:)+0.5*sum(ressq(:,ones(1,nst)).*S,1)';
elseif ~sigswitch
    nupost=nu0+0.5*n;
    sigpost=sig0+0.5*sum(ressq);
end

sig(1,1,:)=(gamrnd(nupost(:,1),1./sigpost(:,1))).^(-1);
detsig=reshape(sig,1,sigswitch*nst+(1-sigswitch));
